import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.IOException;

public class Graph {
		private static int sity = 0;
		private static int roads = 0;


public static void main(String[] args) throws IOException {
		File file;
		int  flag=0;
	
		File file1 = new File("graph.in");
		  byte[] bytes = new byte[(int) file1.length()];
		  FileInputStream fis = new FileInputStream(file1);  
		  fis.read(bytes);
		  fis.close();

		  String[] valueStr = new String(bytes).trim().split("\\s+");
		  		sity=Integer.parseInt(valueStr[0]);
		  		roads=Integer.parseInt(valueStr[1]);
		
	
		  		int var1=0,var2=0,var3,count=0;
				int [][] InGraph = new int[roads][3];
				int [][] out = new int [sity][sity];
				
				for(flag=2;flag<(roads*3);flag++){
					var1=Integer.parseInt(valueStr[flag]);
					var2=Integer.parseInt(valueStr[flag+1]);
					var3=Integer.parseInt(valueStr[flag+2]);
					
					if(var1>var2){
						InGraph[count][0]= var2-1;
						InGraph[count][1]=var1-1;
						InGraph[count][2]=var3;
						out [var2-1][var1-1]=count+1;
					}
					else{
						InGraph[count][1]=var2-1;
						InGraph[count][0]=var1-1;
						InGraph[count][2]=var3;
					   out [var1-1][var2-1]=count+1;
					}
				flag=flag+2;
				count++;
			}

	int[] U = new int [sity];
	int [][] MinimalTree = new int[sity-1][3];
	int num_edges = 0; 
	int next_edge = 0; 
	int a, b, i, j;

if(roads<40000)
	insertionSort(InGraph);
else{
	quickSort(InGraph,0,InGraph.length-1);
}

	 for (flag = 0; flag < sity; flag++)
		 U[flag]=flag;
	
	
	for (i = 0; i < sity - 1; i++)
		for (j = 0; j < 3; j++)
			MinimalTree[i][j] = -1; 
var1=0;var2=0;var3=0;//reuse
	
	while (num_edges < sity - 1){ 
		a = InGraph[next_edge][0];
		b = InGraph[next_edge][1];
	    var1=a;
	    var2 = var1;
	while (U[var2] != var2)
		var2 = U[var2];
	    i=var2;
	    var3=b;
		int var4;
		var4 =var3 ;
	while (U[var4] != var4)
		var4 = U[var4];
	j=var4;
	if (equal(i,j)==0)
	{ if (i < j)
		U[j] = i;
		else
		U[i] = j;
	MinimalTree[num_edges][0] = InGraph[next_edge][0];
	MinimalTree[num_edges][1] = InGraph[next_edge][1];
	MinimalTree[num_edges][2] = InGraph[next_edge][2];
	num_edges++;
     }
		next_edge++;
	}
	
	FileOutputStream fos = null;
	try {
		file = new File("graph.out");
		fos = new FileOutputStream(file);
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		} catch (FileNotFoundException e) {
		e.printStackTrace();
	}
	PrintStream ps = new PrintStream(fos);
		
		
	for (i = 0; i < sity - 1; i++)
	{ 
		var1=MinimalTree[i][0];
		var2=MinimalTree[i][1];
		if(var1>var2){	
			ps.println(out[var2][var1]);
		}
		else{
			ps.println(out[var1][var2]);
		}
	}
}
	
	static int equal (int p, int q)
	{ if (p == q)
	return (1);
	else
	return (0);
	}
	
	
	
    public static void quickSort (int comparableArray[][], int lowIndex, int highIndex){
    if (lowIndex>=highIndex){
   
    return;
      }
  
    int pivotIndex=getMedianIndexAsPivotIndex(lowIndex, highIndex);
      int pivot=comparableArray[pivotIndex][2];
    swap(comparableArray, pivotIndex, highIndex);  
   
    int i=lowIndex-1;
    int j=highIndex; 
    do{ 
    do {i++;} while (comparableArray[i][2]<pivot);
     do {j--;} while (comparableArray[j][2]>pivot &&(j>lowIndex));
     	if (i<j){
    	swap(comparableArray, i, j);
       }
      } while (i<j);
       
    
    swap(comparableArray, highIndex, i);
    quickSort(comparableArray, lowIndex, i-1); 
   quickSort(comparableArray, i+1, highIndex); 
    }
    private static int getMedianIndexAsPivotIndex(int lowIndex, int highIndex) {
    return lowIndex+((highIndex-lowIndex)/2);
  }
  
     

    private static void swap(int[][] a, int i, int j) {
    	int temp = a[i][0];
        int temp1 = a[i][1];
        int temp2 = a[i][2];
         a[i][0]=a[j][0];
         a[i][1]=a[j][1];
         a[i][2]=a[j][2];
         a[j][1] = temp1;
         a[j][2] = temp2;
        a[j][0] = temp;
    }
    static void insertionSort(int[][] arr) {
        int i, j, newValue1,newValue2,newValue3;
        for (i = 1; i < arr.length; i++) {
              newValue1 = arr[i][2];
              newValue2=arr[i][0];
              newValue3=arr[i][1];
              j = i;
              while (j > 0 && arr[j - 1][2] > newValue1) {
                    arr[j][2] = arr[j - 1][2];
                    arr[j][0] = arr[j - 1][0];
                    arr[j][1] = arr[j - 1][1];
                    j--;
              }
              arr[j][2] = newValue1;
              arr[j][0] = newValue2;
              arr[j][1] = newValue3;
        		}
    		}
	}
	
	

